#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "vpu2kernel4xi.py">
#<abstract4xi abstract = "VPU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "vpu2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'VPU2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4vpu',                      # ACK               

            'execute2kernel4vpu',                  # ACK 5.8    p169                                             
            'execute2task4vpu',                    # ACK 5.8    p172   
            'execute2nativekernel4vpu',            # ACK 5.8    p174     
            
            'create2kernel4vpu',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4vpu',         # ACK 5.7.1  p158  
                       
            'delete2kernel4vpu',                   # ACK

            'fetch2kernel4vpu',                    # ACK 
            
            'get2kernelinfo4vpu',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4vpu',         # ACK 5.7.3  p164  
            'get2kernelarginfo4vpu',               # ACK 5.7.3  p166                                  
            
            'release2kernel4vpu',                  # ACK 5.7.1  p159                                         
            'retain2kernel4vpu',                   # ACK 5.7.1  p159   
 
            'set2kernel4vpu',                      # ACK 
            'set2kernelcallback4vpu',              # ACK 
            'set2kernelarg4vpu',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4vpu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from vpu2buffer4xi import get2bufferinfo4vpu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from vpu2commandqueue4xi import VPU2CommandQueue4Xi
from vpu2commandqueue4xi import create2commandqueue4vpu 
from vpu2commandqueue4xi import flush2commandqueue4vpu
from vpu2commandqueue4xi import finish2commandqueue4vpu
from vpu2commandqueue4xi import get2commandqueueinfo4vpu
from vpu2commandqueue4xi import release2commandqueue4vpu
from vpu2commandqueue4xi import retain2commandqueue4vpu
from vpu2commandqueue4xi import set2commandqueue4vpu
from vpu2commandqueue4xi import trace2commandqueue4vpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from vpu2context4xi import VPU2Context4Xi 
from vpu2context4xi import create2context4vpu
from vpu2context4xi import get2context4vpu
from vpu2context4xi import release2context4vpu
from vpu2context4xi import retain2context4vpu
from vpu2context4xi import set2context4vpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from vpu2device4xi import VPU4Xi
from vpu2device4xi import init2vpu4xi 
from vpu2device4xi import set2vpu4xi
from vpu2device4xi import get2vpu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from vpu2event4xi import VPU2Event4Xi
from vpu2event4xi import create2event4vpu
from vpu2event4xi import get2eventinfo4vpu
from vpu2event4xi import release2event4vpu
from vpu2event4xi import retain2event4vpu
from vpu2event4xi import set2eventcallback4vpu 
from vpu2event4xi import set2event4vpu
from vpu2event4xi import trace2event4vpu
from vpu2event4xi import wait2event4vpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from vpu2program4xi import VPU2Program4Xi
from vpu2program4xi import add2programwithsource4vpu
from vpu2program4xi import add2programwithbinary4vpu
from vpu2program4xi import build2program4vpu
from vpu2program4xi import compile2program4vpu
from vpu2program4xi import create2programwithsource4vpu
from vpu2program4xi import create2programwithbinary4vpu
from vpu2program4xi import delete2programwithsource4vpu
from vpu2program4xi import delete2programwithbinary4vpu
from vpu2program4xi import get2programinfo4vpu
# from vpu2program4xi import get2programbuildinfo4vpu
from vpu2program4xi import link2program4vpu
from vpu2program4xi import release2program4vpu
from vpu2program4xi import retain2program4vpu
from vpu2program4xi import set2programcallback4vpu 
from vpu2program4xi import set2programwithsource4vpu
from vpu2program4xi import set2programwithbinary4vpu
from vpu2program4xi import trace2program4vpu
# from vpu2program4xi import unload2compiler4vpu

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global vpu2kernel4xi                                                    # Kernel of VPU
global vpu2build4xi                                                     # Build of VPU
global vpu2compile4xi                                                   # Compile of VPU
global vpu2trace4xi                                                     # TRACE

global fetch2code4vpu                                                   # Fetched code

global import2use4vpu                                                   # Imports of target function for Process4Xi

global kb2fetch4vpu                                                     # Knowledgebase for fetching
global kb2kernel4vpu                                                    # Knowledgebase for kernel   

global folder2lib4vpu                                                   # Folder of VPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4vpu

global target2function4vpu                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2vpu = 'vpu'
key2dir = temp2vpu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4vpu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4vpu = profile2fetch.keys()

kb2fetch4vpu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4vpu[1] = folder2lib4vpu + 'vpu2sampler4xi5test.py'                                                         # Python code
kb2fetch4vpu[2] = folder2lib4vpu + '__pycache__//vpu2sampler4xi.cpython-33.pyc'   
kb2fetch4vpu[3] = folder2lib4vpu + 'vpu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4vpu[4] = folder2lib4vpu + "bin//vpu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4vpu[1]  = folder2lib4vpu + 'vpu2sampler4xi5test.py'                                                      
# kb2fetch4vpu[2]  = folder2lib4vpu + '__pycache__//vpu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4vpu[3]  = folder2lib4vpu + 'vpu2image4xi5test.py'
# kb2fetch4vpu[4]  = folder2lib4vpu + '__pycache__//vpu2image4xi.cpython-33.pyc'
# kb2fetch4vpu[5]  = folder2lib4vpu + 'vpu3image4xi5test.py'
# kb2fetch4vpu[6]  = folder2lib4vpu + '__pycache__//vpu3image4xi.cpython-33.pyc'
# kb2fetch4vpu[7]  = folder2lib4vpu + 'vpu2commandqueue4xi5test.py'
# kb2fetch4vpu[8]  = folder2lib4vpu + '__pycache__//vpu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4vpu[9]  = folder2lib4vpu + 'vpu2event4xi5test.py'
# kb2fetch4vpu[10] = folder2lib4vpu + '__pycache__//vpu2event4xi.cpython-33.pyc'
# kb2fetch4vpu[10]  = folder2lib4vpu + 'VPU2kernel4xi5test.py'
# kb2fetch4vpu[11] = folder2lib4vpu + '__pycache__//vpu2program.cpython-33.pyc'

fetch2code4vpu = {}                                                                                                 # reception arena in memory for code

kb2kernel4vpu = {}
kb2kernel4vpu ['.py'] = {}
kb2kernel4vpu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4vpu ['.py'] ['VALUE']          = "vpu2sampler4xi5test" 
kb2kernel4vpu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4vpu ['.cpp'] = {}
kb2kernel4vpu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4vpu ['.cpp'] ['VALUE']          = "vpu2dummy4xi5test" 
kb2kernel4vpu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of VPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import create2commandqueue4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import flush2commandqueue4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import finish2commandqueue4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4vpu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import get2commandqueueinfo4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import release2commandqueue4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import retain2commandqueue4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importset2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import set2commandqueue4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4vpu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4vpu():
   global target2function4vpu
   from vpu2commandqueue4xi import trace2commandqueue4vpu as target2function4vpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4vpu" usage = " importing target function for Process4Xi">
def importcreate2context4vpu():
   global target2function4vpu
   from vpu2context4xi import create2context4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2context4vpu" usage = " importing target function for Process4Xi">
def importget2context4vpu():
   global target2function4vpu
   from vpu2context4xi import get2context4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importrelease2context4vpu" usage = " importing target function for Process4Xi">
def importrelease2context4vpu():
   global target2function4vpu
   from vpu2context4xi import release2context4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importretain2context4vpu" usage = " importing target function for Process4Xi">
def importretain2context4vpu():
   global target2function4vpu
   from vpu2context4xi import retain2context4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importset2context4vpu" usage = " importing target function for Process4Xi">
def importset2context4vpu():
   global target2function4vpu
   from vpu2context4xi import set2context4vpu as target2function4vpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of VPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2vpu4xi" usage = " importing target function for Process4Xi">
def importinit2vpu4xi():
   global target2function4vpu
   from vpu2device4xi import init2vpu4xi as target2function4vpu 
#</function4xi>
 
#<function4xi function = "importset2vpu4xi" usage = " importing target function for Process4Xi">
def importset2vpu4xi():
   global target2function4vpu
   from vpu2device4xi import set2vpu4xi   as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2vpu4xi" usage = " importing target function for Process4Xi">
def importget2vpu4xi():
   global target2function4vpu
   from vpu2device4xi import get2vpu4xi   as target2function4vpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4vpu" usage = " importing target function for Process4Xi">
def importcreate2event4vpu():
   global target2function4vpu
   from vpu2event4xi import create2event4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4vpu" usage = " importing target function for Process4Xi">
def importget2eventinfo4vpu():
   global target2function4vpu
   from vpu2event4xi import get2eventinfo4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importrelease2event4vpu" usage = " importing target function for Process4Xi">
def importrelease2event4vpu():
   global target2function4vpu
   from vpu2event4xi import release2event4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importretain2event4vpu" usage = " importing target function for Process4Xi">
def importretain2event4vpu():
   global target2function4vpu
   from vpu2event4xi import retain2event4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4vpu" usage = " importing target function for Process4Xi">
def importset2eventcallback4vpu():
   global target2function4vpu
   from vpu2event4xi import set2eventcallback4vpu as target2function4vpu 
#</function4xi>
 
#<function4xi function = "importset2event4vpu" usage = " importing target function for Process4Xi">
def importset2event4vpu():
   global target2function4vpu
   from vpu2event4xi import set2event4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importtrace2event4vpu" usage = " importing target function for Process4Xi">
def importtrace2event4vpu():
   global target2function4vpu
   from vpu2event4xi import trace2event4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importwait2event4vpu" usage = " importing target function for Process4Xi">
def importwait2event4vpu():
   global target2function4vpu
   from vpu2event4xi import wait2event4vpu as target2function4vpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4vpu" usage = " importing target function for Process4Xi">
def importcreate2image4vpu():
   global target2function4vpu
   from vpu2image4xi import create2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4vpu" usage = " importing target function for Process4Xi">
def importget2imageinfo4vpu():
   global target2function4vpu
   from vpu2image4xi import get2imageinfo4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4vpu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4vpu():
   global target2function4vpu
   from vpu2image4xi import get2supportedimageformats4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4vpu():
   global target2function4vpu
   from vpu2image4xi import manoeuvre2copyimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4vpu():
   global target2function4vpu
   from vpu2image4xi import manoeuvre2copyimagetobuffer4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4vpu():
   global target2function4vpu
   from vpu2image4xi import manoeuvre2copybuffertoimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4vpu():
   global target2function4vpu
   from vpu2image4xi import manoeuvre2readimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4vpu():
   global target2function4vpu
   from vpu2image4xi import manoeuvre2writeimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4vpu():
   global target2function4vpu
   from vpu2image4xi import manoeuvre2mapimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importcopy2image4vpu" usage = " importing target function for Process4Xi">
def importcopy2image4vpu():
   global target2function4vpu
   from vpu2image4xi import copy2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4vpu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4vpu():
   global target2function4vpu
   from vpu2image4xi import copy2imagetobuffer4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4vpu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4vpu():
   global target2function4vpu
   from vpu2image4xi import copy2buffertoimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importread2image4vpu" usage = " importing target function for Process4Xi">
def importread2image4vpu():
   global target2function4vpu
   from vpu2image4xi import read2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmap2image4vpu" usage = " importing target function for Process4Xi">
def importmap2image4vpu():
   global target2function4vpu
   from vpu2image4xi import map2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importrelease2image4vpu" usage = " importing target function for Process4Xi">
def importrelease2image4vpu():
   global target2function4vpu
   from vpu2image4xi import release2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importretain2image4vpu" usage = " importing target function for Process4Xi">
def importretain2image4vpu():
   global target2function4vpu
   from vpu2image4xi import retain2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4vpu" usage = " importing target function for Process4Xi">
def importset2imagecallback4vpu():
   global target2function4vpu
   from vpu2image4xi import set2imagecallback4vpu as target2function4vpu 
#</function4xi>
 
#<function4xi function = "importset2image4vpu" usage = " importing target function for Process4Xi">
def importset2image4vpu():
   global target2function4vpu
   from vpu2image4xi import set2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importtrace2image4vpu" usage = " importing target function for Process4Xi">
def importtrace2image4vpu():
   global target2function4vpu
   from vpu2image4xi import trace2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importwait2image4vpu" usage = " importing target function for Process4Xi">
def importwait2image4vpu():
   global target2function4vpu
   from vpu2image4xi import wait2image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importwrite2image4vpu" usage = " importing target function for Process4Xi">
def importwrite2image4vpu():
   global target2function4vpu
   from vpu2image4xi import write2image4vpu as target2function4vpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4vpu" usage = " importing target function for Process4Xi">
def importcreate3image4vpu():
   global target2function4vpu
   from vpu3image4xi import create3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4vpu" usage = " importing target function for Process4Xi">
def importget3imageinfo4vpu():
   global target2function4vpu
   from vpu3image4xi import get3imageinfo4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4vpu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4vpu():
   global target2function4vpu
   from vpu3image4xi import get3supportedimageformats4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4vpu():
   global target2function4vpu
   from vpu3image4xi import manoeuvre3copyimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4vpu():
   global target2function4vpu
   from vpu3image4xi import manoeuvre3copyimagetobuffer4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4vpu():
   global target2function4vpu
   from vpu3image4xi import manoeuvre3copybuffertoimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4vpu():
   global target2function4vpu
   from vpu3image4xi import manoeuvre3readimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4vpu():
   global target2function4vpu
   from vpu3image4xi import manoeuvre3writeimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4vpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4vpu():
   global target2function4vpu
   from vpu3image4xi import manoeuvre3mapimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importcopy3image4vpu" usage = " importing target function for Process4Xi">
def importcopy3image4vpu():
   global target2function4vpu
   from vpu3image4xi import copy3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4vpu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4vpu():
   global target2function4vpu
   from vpu3image4xi import copy3imagetobuffer4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4vpu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4vpu():
   global target2function4vpu
   from vpu3image4xi import copy3buffertoimage4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importread3image4vpu" usage = " importing target function for Process4Xi">
def importread3image4vpu():
   global target2function4vpu
   from vpu3image4xi import read3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importmap3image4vpu" usage = " importing target function for Process4Xi">
def importmap3image4vpu():
   global target2function4vpu
   from vpu3image4xi import map3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importrelease3image4vpu" usage = " importing target function for Process4Xi">
def importrelease3image4vpu():
   global target2function4vpu
   from vpu3image4xi import release3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importretain3image4vpu" usage = " importing target function for Process4Xi">
def importretain3image4vpu():
   global target2function4vpu
   from vpu3image4xi import retain3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4vpu" usage = " importing target function for Process4Xi">
def importset3imagecallback4vpu():
   global target2function4vpu
   from vpu3image4xi import set3imagecallback4vpu as target2function4vpu 
#</function4xi>
 
#<function4xi function = "importset3image4vpu" usage = " importing target function for Process4Xi">
def importset3image4vpu():
   global target2function4vpu
   from vpu3image4xi import set3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importtrace3image4vpu" usage = " importing target function for Process4Xi">
def importtrace3image4vpu():
   global target2function4vpu
   from vpu3image4xi import trace3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importwait3image4vpu" usage = " importing target function for Process4Xi">
def importwait3image4vpu():
   global target2function4vpu
   from vpu3image4xi import wait3image4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importwrite3image4vpu" usage = " importing target function for Process4Xi">
def importwrite3image4vpu():
   global target2function4vpu
   from vpu3image4xi import write3image4vpu as target2function4vpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4vpu" usage = " importing target function for Process4Xi">
def importcreate2sampler4vpu():
   global target2function4vpu
   from vpu2sampler4xi import create2sampler4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4vpu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4vpu():
   global target2function4vpu
   from vpu2sampler4xi import get2samplerinfo4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4vpu" usage = " importing target function for Process4Xi">
def importrelease2sampler4vpu():
   global target2function4vpu
   from vpu2sampler4xi import release2sampler4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importretain2sampler4vpu" usage = " importing target function for Process4Xi">
def importretain2sampler4vpu():
   global target2function4vpu
   from vpu2sampler4xi import retain2sampler4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4vpu" usage = " importing target function for Process4Xi">
def importset2samplercallback4vpu():
   global target2function4vpu
   from vpu2sampler4xi import set2samplercallback4vpu as target2function4vpu 
#</function4xi>
 
#<function4xi function = "importset2sampler4vpu" usage = " importing target function for Process4Xi">
def importset2sampler4vpu():
   global target2function4vpu
   from vpu2sampler4xi import set2sampler4vpu as target2function4vpu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4vpu" usage = " importing target function for Process4Xi">
def importtrace2sampler4vpu():
   global target2function4vpu
   from vpu2sampler4xi import trace2sampler4vpu as target2function4vpu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4vpu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4vpu():
   global target2function4vpu
   from vpu2kernel4xi import create2programwithsource4vpu as target2function4vpu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4vpu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4vpu():
   global target2function4vpu
   from vpu2kernel4xi import create2programwithbinary4vpu as target2function4vpu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4vpu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4vpu():
   global target2function4vpu
   from vpu2kernel4xi import add2programwithsource4vpu as target2function4vpu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4vpu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4vpu():
   global target2function4vpu
   from vpu2kernel4xi import add2programwithbinary4vpu as target2function4vpu
#</function4xi>

#<function4xi function = "importbuild2program4vpu" usage = " importing target function for Process4Xi">
def importbuild2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import build2program4vpu as target2function4vpu
#</function4xi>

#<function4xi function = "importbuild2program4vpu" usage = " importing target function for Process4Xi">
def importbuild2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import build2program4vpu as target2function4vpu
#</function4xi>

#<function4xi function = "importcompile2program4vpuX" usage = " importing target function for Process4Xi">
def importcompile2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import compile2program4vpu as target2function4vpu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4vpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4vpu():
   global target2function4vpu
   from vpu2kernel4xi import delete2programwithsource4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4vpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4vpu():
   global target2function4vpu
   from vpu2kernel4xi import delete2programwithbinary4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importget2programinfo4vpuX" usage = " importing target function for Process4Xi">
def importget2programinfo4vpu():
   global target2function4vpu
   from vpu2kernel4xi import get2programinfo4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importlink2program4vpuX" usage = " importing target function for Process4Xi">
def importlink2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import link2program4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importrelease2program4vpuX" usage = " importing target function for Process4Xi">
def importrelease2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import release2program4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importretain2program4vpuX" usage = " importing target function for Process4Xi">
def importretain2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import retain2program4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importset2programcallback4vpuX" usage = " importing target function for Process4Xi">
def importset2programcallback4vpu():
   global target2function4vpu
   from vpu2kernel4xi import set2programcallback4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importset2programwithsource4vpuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4vpu():
   global target2function4vpu
   from vpu2kernel4xi import set2programwithsource4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4vpuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4vpu():
   global target2function4vpu
   from vpu2kernel4xi import set2programwithbinary4vpu as target2function4vpu
#</function4xi>    

#<function4xi function = "importtrace2program4vpuX" usage = " importing target function for Process4Xi">
def importtrace2program4vpu():
   global target2function4vpu
   from vpu2kernel4xi import trace2program4vpu as target2function4vpu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of VPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importvpu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importvpu2commandqueue4xi5test():
   global target2function4vpu
   from vpu2commandqueue4xi5test import vpu2commandqueue4xi5test as target2function4vpu
#</function4xi> 

#<function4xi function = "importvpu2event4xi5test" usage = " importing target function for Process4Xi">
def importvpu2event4xi5test():
   global target2function4vpu
   from vpu2event4xi5test import vpu2event4xi5test as target2function4vpu
#</function4xi>
 
#<function4xi function = "importvpu2image4xi5test" usage = " importing target function for Process4Xi">
def importvpu2image4xi5test():
   global target2function4vpu
   from vpu2image4xi5test import vpu2image4xi5test as target2function4vpu
#</function4xi>
 
#<function4xi function = "importvpu3image4xi5test" usage = " importing target function for Process4Xi">
def importvpu3image4xi5test():
   global target2function4vpu
   from vpu3image4xi5test import vpu3image4xi5test as target2function4vpu
#</function4xi>
 
#<function4xi function = "importvpu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importvpu2sampler4xi5test():
   global target2function4vpu
   from vpu2sampler4xi5test import vpu2sampler4xi5test as target2function4vpu
#</function4xi>
 
#<function4xi function = "importVPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importvpu2kernel4xi5test():
   global target2function4vpu
   from vpu2kernel4xi5test import vpu2kernel4xi5test as target2function4vpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of VPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4vpu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4vpu():
   global import2use4vpu
   print ("HANDLE2ERROR4VPU OF VPU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4vpu = import2use4vpu.keys()
   for key2import4vpu in keys2import4vpu:
       print(key2import4vpu,import2use4vpu[key2import4vpu]) 
#</function4xi> 


import2use4vpu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of VPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4vpu["create2commandqueue4vpu"] = importcreate2commandqueue4vpu        
import2use4vpu["flush2commandqueue4vpu"] = importflush2commandqueue4vpu 
import2use4vpu["finish2commandqueue4vpu"] = importfinish2commandqueue4vpu 
import2use4vpu["get2commandqueueinfo4vpu"] = importget2commandqueueinfo4vpu 
import2use4vpu["release2commandqueue4vpu"] = importrelease2commandqueue4vpu 
import2use4vpu["retain2commandqueue4vpu"] = importretain2commandqueue4vpu 
import2use4vpu["set2commandqueue4vpu"] = importset2commandqueue4vpu 
import2use4vpu["trace2commandqueue4vpu"] = importtrace2commandqueue4vpu 

# -------------------------------------------------------------------------------------------------
# Context module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4vpu["create2context4vpu"] = importcreate2context4vpu 
import2use4vpu["get2context4vpu"] = importget2context4vpu 
import2use4vpu["release2context4vpu"] = importrelease2context4vpu 
import2use4vpu["retain2context4vpu"] = importretain2context4vpu 
import2use4vpu["set2context4vpu"] = importset2context4vpu 

# -------------------------------------------------------------------------------------------------
# Device module of VPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4vpu["init2vpu4xi"] = importinit2vpu4xi 
import2use4vpu["set2vpu4xi"] = importset2vpu4xi 
import2use4vpu["get2vpu4xi"] = importget2vpu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4vpu["create2event4vpu"] = importcreate2event4vpu 
import2use4vpu["get2eventinfo4vpu"] = importget2eventinfo4vpu 
import2use4vpu["release2event4vpu"] = importrelease2event4vpu 
import2use4vpu["retain2event4vpu"] = importretain2event4vpu 
import2use4vpu["set2eventcallback4vpu"] = importset2eventcallback4vpu 
import2use4vpu["set2event4vpu"] = importset2event4vpu 
import2use4vpu["trace2event4vpu"] = importtrace2event4vpu 
import2use4vpu["wait2event4vpu"] = importwait2event4vpu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4vpu["create2image4vpu"] = importcreate2image4vpu 
import2use4vpu["get2imageinfo4vpu"] = importget2imageinfo4vpu 
import2use4vpu["get2supportedimageformats4vpu"] = importget2supportedimageformats4vpu 
import2use4vpu["manoeuvre2copyimage4vpu"] = importmanoeuvre2copyimage4vpu 
import2use4vpu["manoeuvre2copyimagetobuffer4vpu"] = importmanoeuvre2copyimagetobuffer4vpu 
import2use4vpu["manoeuvre2copybuffertoimage4vpu"] = importmanoeuvre2copybuffertoimage4vpu 
import2use4vpu["manoeuvre2readimage4vpu"] = importmanoeuvre2readimage4vpu 
import2use4vpu["manoeuvre2writeimage4vpu"] = importmanoeuvre2writeimage4vpu 
import2use4vpu["manoeuvre2mapimage4vpu"] = importmanoeuvre2mapimage4vpu 
import2use4vpu["copy2image4vpu"] = importcopy2image4vpu 
import2use4vpu["copy2imagetobuffer4vpu"] = importcopy2imagetobuffer4vpu 
import2use4vpu["copy2buffertoimage4vpu"] = importcopy2buffertoimage4vpu 
import2use4vpu["read2image4vpu"] = importread2image4vpu 
import2use4vpu["map2image4vpu"] = importmap2image4vpu 
import2use4vpu["release2image4vpu"] = importrelease2image4vpu 
import2use4vpu["retain2image4vpu"] = importretain2image4vpu 
import2use4vpu["set2imagecallback4vpu"] = importset2imagecallback4vpu 
import2use4vpu["set2image4vpu"] = importset2image4vpu 
import2use4vpu["trace2image4vpu"] = importtrace2image4vpu 
import2use4vpu["wait2image4vpu"] = importwait2image4vpu 
import2use4vpu["write2image4vpu"] = importwrite2image4vpu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4vpu["create3image4vpu"] = importcreate3image4vpu 
import2use4vpu["get3imageinfo4vpu"] = importget3imageinfo4vpu 
import2use4vpu["get3supportedimageformats4vpu"] = importget3supportedimageformats4vpu 
import2use4vpu["manoeuvre3copyimage4vpu"] = importmanoeuvre3copyimage4vpu 
import2use4vpu["manoeuvre3copyimagetobuffer4vpu"] = importmanoeuvre3copyimagetobuffer4vpu 
import2use4vpu["manoeuvre3copybuffertoimage4vpu"] = importmanoeuvre3copybuffertoimage4vpu 
import2use4vpu["manoeuvre3readimage4vpu"] = importmanoeuvre3readimage4vpu 
import2use4vpu["manoeuvre3writeimage4vpu"] = importmanoeuvre3writeimage4vpu 
import2use4vpu["manoeuvre3mapimage4vpu"] = importmanoeuvre3mapimage4vpu 
import2use4vpu["copy3image4vpu"] = importcopy3image4vpu 
import2use4vpu["copy3imagetobuffer4vpu"] = importcopy3imagetobuffer4vpu 
import2use4vpu["copy3buffertoimage4vpu"] = importcopy3buffertoimage4vpu 
import2use4vpu["read3image4vpu"] = importread3image4vpu 
import2use4vpu["map3image4vpu"] = importmap3image4vpu 
import2use4vpu["release3image4vpu"] = importrelease3image4vpu 
import2use4vpu["retain3image4vpu"] = importretain3image4vpu 
import2use4vpu["set3imagecallback4vpu"] = importset3imagecallback4vpu 
import2use4vpu["set3image4vpu"] = importset3image4vpu 
import2use4vpu["trace3image4vpu"] = importtrace3image4vpu 
import2use4vpu["wait3image4vpu"] = importwait3image4vpu 
import2use4vpu["write3image4vpu"] = importwrite3image4vpu 

# -------------------------------------------------------------------------------------------------
# Sampler module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4vpu["create2sampler4vpu"] = importcreate2sampler4vpu 
import2use4vpu["get2samplerinfo4vpu"] = importget2samplerinfo4vpu 
import2use4vpu["release2sampler4vpu"] = importrelease2sampler4vpu 
import2use4vpu["retain2sampler4vpu"] = importretain2sampler4vpu 
import2use4vpu["set2samplercallback4vpu"] = importset2samplercallback4vpu 
import2use4vpu["set2sampler4vpu"] = importset2sampler4vpu 
import2use4vpu["trace2sampler4vpu"] = importtrace2sampler4vpu 

# -------------------------------------------------------------------------------------------------
# Program module of VPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4vpu["trace2program4vpu"] = importtrace2program4vpu
import2use4vpu["set2programwithbinary4vpu"] = importset2programwithbinary4vpu
import2use4vpu["set2programwithsource4vpu"] = importset2programwithsource4vpu
import2use4vpu["set2programcallback4vpu"] = importset2programcallback4vpu
import2use4vpu["retain2program4vpu"] = importretain2program4vpu
import2use4vpu["release2program4vpu"] = importrelease2program4vpu
import2use4vpu["link2program4vpu"] = importlink2program4vpu
import2use4vpu["get2programinfo4vpu"] = importget2programinfo4vpu
import2use4vpu["delete2programwithbinary4vpu"] = importdelete2programwithbinary4vpu
import2use4vpu["delete2programwithsource4vpu"] = importdelete2programwithsource4vpu
import2use4vpu["compile2program4vpu"] = importcompile2program4vpu
import2use4vpu["build2program4vpu"] = importbuild2program4vpu
import2use4vpu["build2program4vpu"] = importbuild2program4vpu
import2use4vpu["add2programwithbinary4vpu"] = importadd2programwithbinary4vpu
import2use4vpu["add2programwithsource4vpu"] = importadd2programwithsource4vpu
import2use4vpu["create2programwithbinary4vpu"] = importcreate2programwithbinary4vpu
import2use4vpu["create2programwithsource4vpu"] = importcreate2programwithsource4vpu



# -------------------------------------------------------------------------------------------------
# Test modules of VPU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4vpu["vpu2commandqueue4xi5test"] = importvpu2commandqueue4xi5test 
import2use4vpu["vpu2event4xi5test"] = importvpu2event4xi5test 
import2use4vpu["vpu2image4xi5test"] = importvpu2image4xi5test 
import2use4vpu["vpu3image4xi5test"] = importvpu3image4xi5test 
import2use4vpu["vpu2sampler4xi5test"] = importvpu2sampler4xi5test 
import2use4vpu["vpu2kernel4xi5test"] = importvpu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4vpu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF VPU2KERNEL4XI5TEST - TRYING TO TRACE VPU: ', time4xi())      
#   print('=' *33)      
#   trace2vpu = None
#   try:
#       trace2vpu = trace2kernel4vpu() 
#       print('(Step 15B/25) OF VPU2KERNEL4XI5TEST - TRACE2VPU: ', trace2vpu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4vpu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4vpu', 'METHOD': 'trace2kernel4vpu'} 
#   except:
#       print('(Step 15Z1/25) OF VPU2KERNEL4XI5TEST *** FAILED TO TRACE VPU: ', trace2vpu) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4vpu(task4trace2vpu=None):  

    '''
    creates callback to vpu2kernel4xi
    '''
    
    global vpu2trace4xi
    global folder2lib4vpu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4vpu" 
    method2print = "trace2kernel4vpu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4vpu-started: " + str(trace2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2vpu-to-trace2kernel4vpu: " + str(task4trace2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    vpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2vpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY VPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2vpu = {}                                                                                            
            
        task4trace2vpu['CLASS']   = "trace2kernel4vpu"                                                              # VPUIZE ZPU TRACE!
        task4trace2vpu['METHOD']  = "trace2kernel4vpu" 
        task4trace2vpu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4vpu-failed " + str(vpu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2vpu-set-by-trace2kernel4vpu to: " + str(task4trace2vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY VPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2vpu-try-by-trace2kernel4vpu: " + str(task4trace2vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        vpu2trace4xi ['CLASS']  = task4trace2vpu['CLASS']                                                           # VPUIZE VPU TRACE!
        vpu2trace4xi ['METHOD']  = task4trace2vpu['METHOD']
        vpu2trace4xi ['MESSAGE'] = task4trace2vpu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; vpu2trace4xi-set-by-trace2kernel4vpu to: " + str(vpu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; vpu-trace-failed-by-trace2kernel4vpu: " + str(task4trace2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE VPU TRACE
        # =================================
        class2print   = task4trace2vpu['CLASS']                                                                     # VPUIZE VPU TRACE!
        method2print  = task4trace2vpu['METHOD']
        
        message2print = task4trace2vpu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # VPUIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4vpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4vpu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-vpu-trace-failed-by-trace2kernel4vpu: " + str(task4trace2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4vpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4vpu"                
        message2print = "{(Step 3D/33) performed" + "; vpu-trace-performed-by-trace2kernel4vpu: " + str(task4trace2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; vpu-trace-failed-by-trace2kernel4vpu: " + str(task4trace2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; vpu2trace4xi-returning-by-trace2kernel4vpu: " + str(vpu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return vpu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4vpu" usage = "
#
#   response4execute2kernel = execute2kernel4vpu()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4vpu(task4execute2vpu=None):  

    '''
    executes kernel to VPU 
    '''
    global folder2lib4vpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4vpu" 
    method2print = "execute2kernel4vpu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4vpu-started: " + str(execute2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2vpu-to-execute2kernel4vpu: " + str(task4execute2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2vpu = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2vpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2vpu = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2vpu-set-by-execute2kernel4vpu to: " + str(task4execute2vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2vpu = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2vpu-set-by-execute2kernel4vpu to: " + str(status4execute2vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2vpu-returning-by-execute2kernel4vpu: " + str(status4execute2vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2vpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4vpu" usage = "
#
#   print('(Step 14A/700) OF VPU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF VPU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4vpu()                                                                                                 
#       print('(Step 14B/700) OF VPU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF VPU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF VPU ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4vpu(task4set2kernelcallback=None):

    '''
    registers callback function to vpu2kernel4xi
    '''
    global vpu2kernel4xi
    global folder2lib4vpu  
        
    class2print = "set2kernelcallback4vpu" 
    method2print = "set2kernelcallback4vpu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4vpu-started: " + str(set2kernelcallback4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4vpu-started
    
    try:
    
        vpu2kernel4xi ['CALLBACK'] = trace2kernel4vpu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-vpu2kernel4xi-returning-by-set2kernelcallback4vpu: " + str(vpu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return vpu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4vpu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4vpu-returning-by-set2kernelcallback4vpu: " + str(trace2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4vpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4vpu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4vpu(task4execute2task)
#       print('(Step 99B/700) OF VPU2KERNEL4XI5TEST - BUILT PROGRAM OF VPU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF VPU DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4vpu(task4execute2vpu=None):

    '''
    executes  program to VPU 
    '''
    global vpu2execute4xi
    global folder2lib4vpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4vpu"
    method2print = "execute2task4vpu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4vpu-started: " + str(execute2task4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4vpu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2vpu-to-execute2task4vpu: " + str(task4execute2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4vpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2vpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO VPU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2vpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2vpu-initialized-by-execute2task4vpu: " + str(task4execute2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2vpu = {}
            message2print = "{(Step 1A/70) trying" + "; program2vpu-trying-by-create2kernel4vpu: " + str(program2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2vpu = create2kernel4vpu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2vpu-got-by-create2kernel4vpu: " + str(program2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2vpu-failed-by-create2kernel4vpu: " + str(program2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2vpu ['PROGRAM'] = program2vpu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4vpu = trace2kernel4vpu                                                               # CALLBACK FUNCTION FOR VPU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4vpu-created-by-execute2task4vpu: " + str(function2callback4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4vpu"                                                            # MODULE OF VPUIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4vpu"                                                            # FUNCTION OF VPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4vpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR VPUIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4vpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2vpu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO VPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2vpu['FUNCTION2CALLBACK'] = function2callback4vpu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2vpu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2vpu-created-by-execute2task4vpu: " + str(task4execute2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2vpu-yielded-by-execute2task4vpu: " + str(task4execute2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2vpu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4vpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR VPU ! 
    # ---------------------------------------------------------------------------------------------    
    vpu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; vpu2execute4xi-initialized-by-execute2task4vpu to: " + str(vpu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4vpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        vpu2execute4xi['PROGRAM'] = task4execute2vpu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4vpu: " + str(vpu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-vpu2execute4xi-yielded-by-execute2task4vpu: " + str(vpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4vpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        vpu2execute4xi['OPTIONS'] = task4execute2vpu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4vpu: " + str(vpu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-vpu2execute4xi-yielded-by-execute2task4vpu: " + str(vpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4vpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        vpu2execute4xi['CALLBACK'] = task4execute2vpu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4vpu: " + str(vpu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-vpu2execute4xi-yielded-by-execute2task4vpu: " + str(vpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4vpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        vpu2execute4xi['USERDATA'] = task4execute2vpu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4vpu: " + str(vpu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-vpu2execute4xi-yielded-by-execute2task4vpu: " + str(vpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2execute4xi ['ACK2RETURN']  = code2ack
    vpu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; vpu2execute4xi-returning-by-execute2task4vpu: " + str(vpu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return vpu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4vpu" usage = "
#     
#   print('(Step 2A1/700) OF VPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR VPU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4vpu()
#   except:
#       print('(Step 2Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR VPU *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4vpu(task4kernel2vpu=None):

    '''
    creates kernel for VPU
    '''
    global vpu2kernel4xi                                                                                            # Kernel of VPU    
    global folder2lib4vpu  
    global kb2kernel4vpu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4vpu" 
    method2print = "create2kernel4vpu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4vpu-started: " + str(create2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4vpu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2vpu-to-create2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    vpu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2vpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO VPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2vpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2vpu-created-by-create2kernel4vpu: " + str(task4kernel2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4vpu = trace2kernel4vpu                                                                # CALLBACK FUNCTION FOR VPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4vpu-created-by-create2kernel4vpu: " + str(function2callback4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4vpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4vpu"                                                          # MODULE OF VPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4vpu"                                                          # FUNCTION OF VPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4vpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR VPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4vpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4vpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4vpu',
            #  'METHOD': 'create2kernel4vpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2vpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO VPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2vpu['FUNCTION2CALLBACK'] = function2callback4vpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2vpu-created-by-create2kernel4vpu: " + str(task4kernel2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4vpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4vpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4vpu',
            #  'METHOD': 'create2kernel4vpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4vpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4vpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4vpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2vpu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2vpu = {}
            message2print = "{(Step 3A/70) trying" + "; context2vpu-trying-by-create2kernel4vpu: " + str(context2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2vpu = get2context4vpu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2vpu-got-by-create2kernel4vpu: " + str(context2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2vpu-failed-by-create2kernel4vpu: " + str(context2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2vpu ['CONTEXT'] = context2vpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2vpu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2vpu-trying-by-create2kernel4vpu: " + str(device2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2vpu = get2vpu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2vpu-got-by-create2kernel4vpu: " + str(device2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2vpu-failed-by-create2kernel4vpu: " + str(device2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2vpu ['DEVICE'] = device2vpu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2vpu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2vpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2vpu-trying-by-create2kernel4vpu: " + str(queue2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2vpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2vpu-got-by-create2kernel4vpu: " + str(queue2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2vpu-failed-by-create2kernel4vpu: " + str(queue2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2vpu ['QUEUE'] = queue2vpu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2vpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2vpu-trying-by-create2kernel4vpu: " + str(pipe2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2vpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2vpu-got-by-create2kernel4vpu: " + str(pipe2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2vpu-failed-by-create2kernel4vpu: " + str(pipe2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2vpu ['PIPE'] = pipe2vpu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2vpu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2vpu-trying-by-create2kernel4vpu: " + str(commandqueueinfo2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2vpu = get2commandqueueinfo4vpu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2vpu-got-by-create2kernel4vpu: " + str(commandqueueinfo2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2vpu-failed-by-create2kernel4vpu: " + str(commandqueueinfo2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2vpu ['COMMANDQUEUE'] = commandqueueinfo2vpu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2vpu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2vpu-trying-by-create2kernel4vpu: " + str(bufferinfo2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2vpu = get2bufferinfo4vpu()                                                               # SYSTEM CREATES BUFFER FOR VPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2vpu-got-by-create2kernel4vpu: " + str(bufferinfo2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2vpu-failed-by-create2kernel4vpu: " + str(bufferinfo2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2vpu ['BUFFER'] = bufferinfo2vpu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2vpu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2vpu-trying-by-create2kernel4vpu: " + str(eventinfo2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2vpu = get2eventinfo4vpu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2vpu-got-by-create2kernel4vpu: " + str(eventinfo2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2vpu-failed-by-create2kernel4vpu: " + str(eventinfo2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2vpu ['EVENT'] = eventinfo2vpu             

            
            task4kernel2vpu ['CODE4PY']       = {}                                                                  
            task4kernel2vpu ['CODE4CPP']      = {}                                                                  
            task4kernel2vpu ['CODE4C']        = {} 
            task4kernel2vpu ['CODE4CL']       = {} 
                       
            task4kernel2vpu ['CODE4PYC']      = {}                                                                  
            task4kernel2vpu ['CODE4BIN']      = {}
 
            task4kernel2vpu ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2vpu ['DIRECTORY4CPP'] = {}
            task4kernel2vpu ['DIRECTORY4C']   = {}
            task4kernel2vpu ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2vpu ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2vpu ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4vpu = folder2lib4vpu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4vpu-set-by-create2kernel4vpu to: " + str(dir2py4vpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2vpu ['DIRECTORY4PY'] = dir2py4vpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4vpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4vpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4vpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4vpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4vpu + vpu2sampler4xi5test.py; vpu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4vpu-calling-by-create2kernel4vpu: " + str(fetch2kernel4vpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4vpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4vpu-by-create2kernel4vpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4vpu + vpu2sampler4xi5test.py; vpu2dummy4xi5test.cpp 
                    
                    fetch2kernel4vpu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4VPU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4vpu-performed-by-create2kernel4vpu: " + str(fetch2kernel4vpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4vpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4vpu-got-by-create2kernel4vpu: " + str(fetch2code4vpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4vpu = fetch2code4vpu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4vpu-using-by-create2kernel4vpu: " + str(keys2explore4vpu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4vpu + vpu2sampler4xi5test.py; vpu2dummy4xi5test.cpp
            
            for key2explore4vpu in keys2explore4vpu:
                name2program4vpu=os.path.splitext(key2explore4vpu)                                                  # vpu2sampler4xi5test + py
                key2extension4vpu = name2program4vpu[1]                                                              
                if key2extension4vpu == '.py':                          
                    task4kernel2vpu ['CODE4PY'] [key2explore4vpu] = fetch2code4vpu[key2explore4vpu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4vpu  = {}
            keys2py4vpu = fetch2code4vpu.keys()                                                                     # vpu2sampler4xi5test.py
            for key2py4vpu in keys2py4vpu:
                name2program4vpu=os.path.splitext(key2py4vpu)                                                       # vpu2sampler4xi5test + py
                key2extension4vpu = name2program4vpu[1]                                                             # py   
                if key2extension4vpu == '.py':                          
                    size2py4vpu[key2py4vpu] = len(fetch2code4vpu[key2py4vpu])                                       # length of saved py code 

            task4kernel2vpu ['SIZE4PY'] = size2py4vpu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4vpu-set-by-create2kernel4vpu to: " + str(size2py4vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4vpu + vpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4vpu = folder2lib4vpu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4vpu-set-by-create2kernel4vpu to: " + str(dir2c4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4vpu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2vpu ['DIRECTORY4CPP']  = dir2c4vpu
            task4kernel2vpu ['DIRECTORY4C']    = dir2c4vpu
            task4kernel2vpu ['DIRECTORY4CLPP'] = dir2c4vpu
            task4kernel2vpu ['CODE4CPP'] = {} 
            task4kernel2vpu ['CODE4C']   = {} 
            task4kernel2vpu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4vpu = fetch2code4vpu.keys()
            for key2c4vpu in keys2c4vpu:
                name2c4vpu=os.path.splitext(key2c4vpu)                                                  
                key2extension4vpu = name2c4vpu[1]                                                             # C++, C, CL 
                if key2extension4vpu == '.cpp':                          
                    task4kernel2vpu ['CODE4CPP'] [key2c4vpu] = fetch2code4vpu[key2c4vpu]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4vpu-set-by-create2kernel4vpu to: " + str(key2c4vpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4vpu + vpu2dummy4xi5test.cpp
                if key2extension4vpu == '.c':                          
                    task4kernel2vpu ['CODE4C'] [key2c4vpu] = fetch2code4vpu[key2c4vpu]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4vpu-set-by-create2kernel4vpu to: " + str(key2c4vpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4vpu +
                if key2extension4vpu == '.cl':                          
                    task4kernel2vpu ['CODE4CL'] [key2c4vpu] = fetch2code4vpu[key2c4vpu]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4vpu-set-by-create2kernel4vpu to: " + str(key2c4vpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4vpu + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4vpu  = {}
            keys2c4vpu = fetch2code4vpu.keys()                                                                # 
            for key2c4vpu in keys2c4vpu:
                name2program4vpu=os.path.splitext(key2c4vpu)                                                  # 
                key2extension4vpu = name2program4vpu[1]                                                       #    
                if key2extension4vpu == '.cpp':                          
                    size2c4vpu[key2c4vpu] = len(fetch2code4vpu[key2c4vpu])                                    # length of saved C++ code
                    task4kernel2vpu ['SIZE4CPP'] = size2c4vpu 
                if key2extension4vpu == '.c':                          
                    size2c4vpu[key2c4vpu] = len(fetch2code4vpu[key2c4vpu])                                    # length of saved C code
                    task4kernel2vpu ['SIZE4C'] = size2c4vpu
                if key2extension4vpu == '.cl':                          
                    size2c4vpu[key2c4vpu] = len(fetch2code4vpu[key2c4vpu])                                    # length of saved CL code
                    task4kernel2vpu ['SIZE4CL'] = size2c4vpu 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4vpu-set-by-create2kernel4vpu to: " + str(size2c4vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu + vpu2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4vpu = folder2lib4vpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4vpu-set-by-create2kernel4vpu to: " + str(dir2pycache4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2vpu ['DIRECTORY4PYC'] = dir2pycache4vpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4vpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4vpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4vpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4vpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4vpu + __pycache__//vpu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4vpu-calling-by-create2kernel4vpu: " + str(fetch2kernel4vpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4vpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4vpu-by-create2kernel4vpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4vpu + __pycache__//vpu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4vpu(file2walk)                                                                     # fetches kernel files into fetch2code4vpu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4vpu-performed-by-create2kernel4vpu: " + str(fetch2kernel4vpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4vpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4vpu-got-by-create2kernel4vpu: " + str(fetch2code4vpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2vpu ['CODE4PYC'] = {}
            keys2pyc4vpu = fetch2code4vpu.keys()
            for key2pyc4vpu in keys2pyc4vpu:
                name2program4vpu=os.path.splitext(key2pyc4vpu)                                                      # vpu2sampler4xi5test.cpython-33.pyc
                key2extension4vpu = name2program4vpu[1]                                                             # pyc 
   
                if key2extension4vpu == '.pyc':                          
                    task4kernel2vpu ['CODE4PYC'] [key2pyc4vpu] = fetch2code4vpu[key2pyc4vpu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4vpu-set-by-create2kernel4vpu to: " + str(key2pyc4vpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4vpu  = {}

            for key2pyc4vpu in keys2pyc4vpu:
                name2program4vpu=os.path.splitext(key2pyc4vpu)                                                      # vpu2sampler4xi5test.cpython-32 + pyc
                key2extension4vpu = name2program4vpu[1]                                                             # pyc 
                if key2extension4vpu == '.pyc':                          
                    size2pyc4vpu[key2pyc4vpu] = len(fetch2code4vpu[key2pyc4vpu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4vpu-set-by-create2kernel4vpu to: " + str(key2pyc4vpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2vpu ['SIZE4PYC'] = size2pyc4vpu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4vpu-set-by-create2kernel4vpu to: " + str(size2pyc4vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4vpu = folder2lib4vpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4vpu-set-by-create2kernel4vpu to: " + str(dir2bin4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2vpu ['DIRECTORY4BIN'] = dir2bin4vpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4vpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4vpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4vpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4vpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4vpu + bin//vpu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4vpu-calling-by-create2kernel4vpu: " + str(fetch2kernel4vpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4vpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4vpu-by-create2kernel4vpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4vpu + bin//vpu2dummy4xi5test.exe
                    
                    fetch2kernel4vpu(file2walk)                                                                     # fetches kernel files into fetch2code4vpu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4vpu-performed-by-create2kernel4vpu: " + str(fetch2kernel4vpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4vpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4vpu-got-by-create2kernel4vpu: " + str(fetch2code4vpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2vpu ['CODE4BIN'] = {}
            
            keys2bin4vpu = fetch2code4vpu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4vpu-using-by-create2kernel4vpu: " + str(keys2bin4vpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4vpu + 'vpu2dummy4xi5test.cpp', 'vpu2sampler4xi5test.py']
            
            for key2bin4vpu in keys2bin4vpu:
                name2program4vpu=os.path.splitext(key2bin4vpu)                                                      # vpu2dummy4xi5test.exe
                key2extension4vpu = name2program4vpu[1]                                                             # bin 
   
                if key2extension4vpu == '.exe':                          
                    task4kernel2vpu ['CODE4BIN'] [key2bin4vpu] = fetch2code4vpu[key2bin4vpu]                        # binary code(s)   
                                        
            size2bin4vpu  = {}
            keys2bin4vpu = fetch2code4vpu.keys()                                                                    # vpu2dummy4xi5test.exe
            for key2bin4vpu in keys2bin4vpu:
                name2program4vpu=os.path.splitext(key2bin4vpu)                                                      # vpu2sampler4xi5test.cpython-32 + bin
                key2extension4vpu = name2program4vpu[1]                                                             # bin 
                if key2extension4vpu == '.exe':                          
                    size2bin4vpu[key2bin4vpu] = len(fetch2code4vpu[key2bin4vpu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2vpu ['SIZE4BIN'] = size2bin4vpu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4vpu-set-by-create2kernel4vpu to: " + str(size2bin4vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2vpu ['COUNT4PY']     = 0
            task4kernel2vpu ['COUNT4CPP']    = 0
            task4kernel2vpu ['COUNT4C']      = 0
            task4kernel2vpu ['COUNT4CL']     = 0
            task4kernel2vpu ['COUNT4PYC']    = 0
            task4kernel2vpu ['COUNT4BIN']    = 0

            keys2code4vpu = fetch2code4vpu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4vpu-using-by-create2kernel4vpu: " + str(keys2code4vpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4vpu + 'vpu2dummy4xi5test.cpp', folder2lib4vpu + 'vpu2sampler4xi5test.py']

            
            for key2code4vpu in keys2code4vpu:
                name2program4vpu=os.path.splitext(key2code4vpu)                                                    
                key2extension4vpu = name2program4vpu[1]                                                             
                if key2extension4vpu == '.py':                          
                    task4kernel2vpu ['COUNT4PY']     = task4kernel2vpu ['COUNT4PY']  + 1 
                if key2extension4vpu == '.cpp':                          
                    task4kernel2vpu ['COUNT4CPP']    = task4kernel2vpu ['COUNT4CPP'] + 1                                            
                if key2extension4vpu == '.c':                          
                    task4kernel2vpu ['COUNT4C']      = task4kernel2vpu ['COUNT4C']   + 1              
                if key2extension4vpu == '.cl':                          
                    task4kernel2vpu ['COUNT4CL']     = task4kernel2vpu ['COUNT4CL']  + 1                                  
                if key2extension4vpu == '.pyc':                          
                    task4kernel2vpu ['COUNT4PYC']    = task4kernel2vpu ['COUNT4PYC'] + 1                            
                if key2extension4vpu == '.exe':                          
                    task4kernel2vpu ['COUNT4BIN']    = task4kernel2vpu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2vpu ['LANGUAGE'] = {}
            
            for key2code4vpu in keys2code4vpu:
                name2program4vpu=os.path.splitext(key2code4vpu)                                                     
                key2extension4vpu = name2program4vpu[1]                                                             
                if key2extension4vpu == '.py':                          
                    task4kernel2vpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4vpu == '.cpp':                          
                    task4kernel2vpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4vpu == '.c':                          
                    task4kernel2vpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4vpu == '.cl':                          
                    task4kernel2vpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2vpu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2vpu-set-by-create2kernel4vpu to: " + str(count2reference2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2vpu ['COUNT2REFERENCE'] = count2reference2vpu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2vpu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2vpu ['PROGRAM'] = create2programwithsource4vpu()
                keys2program = task4kernel2vpu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4vpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2vpu-failed-by-create2kernel4vpu: " + str(task4kernel2vpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2vpu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2vpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4vpu  = kb2kernel4vpu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4vpu-using-by-create2kernel4vpu: " + str(tag2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4vpu    = kb2kernel4vpu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4vpu-using-by-create2kernel4vpu: " + str(value2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # vpu2sampler4xi5test
            
            attribute2search4vpu= kb2kernel4vpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4vpu-using-by-create2kernel4vpu: " + str(attribute2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4vpu in keys2code4vpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu]
                    keys2line4vpu = code2examine4vpu.keys()
                    for key2line4vpu in keys2line4vpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu] [key2line4vpu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4vpu,tag2search4vpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... vpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4vpu,value2search4vpu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4vpu-skipped-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "vpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4vpu,attribute2search4vpu)             # ...function = "vpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4vpu-warning-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4vpu-accepted-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "vpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4vpu = line2examine4vpu[index2function:index2usage-2]
                                    
                                    task4kernel2vpu ['FUNCTION'] ['.py'] [key2pythonfunction4vpu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4vpu-used-by-create2kernel4vpu: " + str(key2pythonfunction4vpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # vpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2vpu-failed-by-create2kernel4vpu: " + str(task4kernel2vpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2vpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4vpu      = kb2kernel4vpu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4vpu-using-by-create2kernel4vpu: " + str(tag2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4vpu= kb2kernel4vpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4vpu-using-by-create2kernel4vpu: " + str(attribute2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4vpu in keys2code4vpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4vpu-using-by-create2kernel4vpu: " + str(key2code4vpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # vpu2dummy4xi5test.cpp
                       
                    keys2line4vpu = code2examine4vpu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4vpu-using-by-create2kernel4vpu: " + str(keys2line4vpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4vpu in keys2line4vpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu] [key2line4vpu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4vpu,tag2search4vpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4vpu-using-by-create2kernel4vpu: " + str(attribute2search4vpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4vpu,attribute2search4vpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4vpu-skipped-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4vpu-accepted-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4vpu = line2examine4vpu[27:index2usage-2]  
                                task4kernel2vpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4vpu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4vpu-used-by-create2kernel4vpu: " + str(key2kernelfunction4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2vpu-failed-by-create2kernel4vpu: " + str(task4kernel2vpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2VPU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2vpu-yielded-by-create2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2vpu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4vpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR VPU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    vpu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; vpu2kernel4xi-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4vpu = trace2kernel4vpu                                                                # CALLBACK FUNCTION FOR VPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4vpu-created-by-create2kernel4vpu: " + str(function2callback4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4vpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4vpu"                                                          # MODULE OF VPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4vpu"                                                          # FUNCTION OF VPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4vpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR VPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4vpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4vpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4vpu',
            #  'METHOD': 'create2kernel4vpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2vpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO VPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2vpu['FUNCTION2CALLBACK'] = function2callback4vpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2vpu-created-by-create2kernel4vpu: " + str(task4kernel2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4vpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4vpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4vpu',
            #  'METHOD': 'create2kernel4vpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['DATA2CALLBACK'] = task4kernel2vpu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4vpu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4vpu',
            #  'METHOD': 'create2kernel4vpu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2vpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4vpu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['PLATFORM'] = task4kernel2vpu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2vpu-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['CONTEXT'] = task4kernel2vpu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['DEVICE'] = task4kernel2vpu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['CODE2ERROR'] = task4kernel2vpu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2vpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2vpu-trying-by-create2kernel4vpu: " + str(queue2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2vpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2vpu-got-by-create2kernel4vpu: " + str(queue2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2vpu-failed-by-create2kernel4vpu: " + str(queue2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2vpu ['QUEUE'] = queue2vpu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['QUEUE'] = task4kernel2vpu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2vpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2vpu-trying-by-create2kernel4vpu: " + str(pipe2vpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2vpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2vpu-got-by-create2kernel4vpu: " + str(pipe2vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2vpu-failed-by-create2kernel4vpu: " + str(pipe2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2vpu ['PIPE'] = pipe2vpu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            vpu2kernel4xi['PIPE'] = task4kernel2vpu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['COMMANDQUEUE']  = task4kernel2vpu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['BUFFER']  = task4kernel2vpu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['EVENT']  = task4kernel2vpu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['COUNT4PY']  = task4kernel2vpu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['COUNT4CPP']  = task4kernel2vpu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['COUNT4C']  = task4kernel2vpu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['COUNT4CL']  = task4kernel2vpu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4vpu: " + str(task4kernel2vpu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['COUNT4PYC']  = task4kernel2vpu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4vpu: " + str(task4kernel2vpu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['COUNT4BIN']  = task4kernel2vpu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4vpu = folder2lib4vpu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4vpu-set-by-create2kernel4vpu to: " + str(dir2py4vpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2vpu ['DIRECTORY4PY'] = dir2py4vpu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['DIRECTORY4PY']  = task4kernel2vpu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4vpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4vpu = folder2lib4vpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4vpu-set-by-create2kernel4vpu to: " + str(dir2cpp4vpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2vpu ['DIRECTORY4CPP'] = dir2cpp4vpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['DIRECTORY4CPP']  = task4kernel2vpu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4vpu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4vpu = folder2lib4vpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4vpu-set-by-create2kernel4vpu to: " + str(dir2c4vpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2vpu ['DIRECTORY4C'] = dir2c4vpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['DIRECTORY4C']  = task4kernel2vpu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4vpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4vpu = folder2lib4vpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4vpu-set-by-create2kernel4vpu to: " + str(dir2cl4vpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2vpu ['DIRECTORY4CL'] = dir2cl4vpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['DIRECTORY4CL']  = task4kernel2vpu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4vpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4vpu = folder2lib4vpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4vpu-set-by-create2kernel4vpu to: " + str(dir2pycache4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2vpu ['DIRECTORY4PYC'] = dir2pycache4vpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['DIRECTORY4PYC']  = task4kernel2vpu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4vpu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4vpu = folder2lib4vpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4vpu-set-by-create2kernel4vpu to: " + str(dir2bin4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4vpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2vpu ['DIRECTORY4BIN'] = dir2bin4vpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['DIRECTORY4BIN']  = task4kernel2vpu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4vpu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4vputask-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4vpu + 'vpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        vpu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['CODE4PY'] = task4kernel2vpu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 'vpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4vpu2nack  = code2py4vpu2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4vputask-try-by-create2kernel4vpu: " + str(len(task4kernel2vpu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4vpu +  vpu2dummy4xi5test.cpp
        
        vpu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['CODE4CPP'] = task4kernel2vpu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4vpu-created-by-create2kernel4vpu: " + str(len(vpu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + vpu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4vpu2nack  = code2cpp4vpu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4vputask-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4vpu + 
        
        vpu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['CODE4C'] = task4kernel2vpu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4vpu2nack  = code2c4vpu2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4vputask-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4vpu + 
        
        vpu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['CODE4CL'] = task4kernel2vpu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4vpu2nack  = code2cl4vpu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4vpu + 
        
        vpu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['CODE4PYC'] = task4kernel2vpu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4vpu2nack  = code2pyc4vpu2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4vpu2bin4vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4vpu + 
        
        vpu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['CODE4BIN'] = task4kernel2vpu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4vpu-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4vpu2nack  = code2bin4vpu2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['SIZE4PY']  = task4kernel2vpu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4vpu-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 'vpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['SIZE4CPP']  = task4kernel2vpu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4vpu-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + vpu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['SIZE4C']  = task4kernel2vpu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4vpu-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4vpu-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['SIZE4CL']  = task4kernel2vpu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4vpu-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4vpu-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['SIZE4PYC']  = task4kernel2vpu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            vpu2kernel4xi['SIZE4BIN']  = task4kernel2vpu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4vpu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2vpu ['LANGUAGE'] = {}
            
            for key2code4vpu in keys2code4vpu:
                name2program4vpu=os.path.splitext(key2code4vpu)                                                     
                key2extension4vpu = name2program4vpu[1]                                                             
                if key2extension4vpu == '.py':                          
                    task4kernel2vpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4vpu == '.cpp':                          
                    task4kernel2vpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4vpu == '.c':                          
                    task4kernel2vpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4vpu == '.cl':                          
                    task4kernel2vpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['LANGUAGE']  = task4kernel2vpu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2vpu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2vpu-set-by-create2kernel4vpu to: " + str(count2reference2vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2vpu ['COUNT2REFERENCE'] = count2reference2vpu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2vpu-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4vpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['COUNT2REFERENCE']  = task4kernel2vpu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4vpu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2vpu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2vpu-try-by-create2kernel4vpu: " + str(task4kernel2vpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2vpu ['PROGRAM'] = create2programwithsource4vpu()
                keys2program = task4kernel2vpu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4vpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2vpu-failed-by-create2kernel4vpu: " + str(task4kernel2vpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4vpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['PROGRAM']  = task4kernel2vpu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4vpu: " + str(len(vpu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2vpu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2vpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4vpu  = kb2kernel4vpu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4vpu-using-by-create2kernel4vpu: " + str(tag2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4vpu    = kb2kernel4vpu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4vpu-using-by-create2kernel4vpu: " + str(value2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # vpu2sampler4xi5test
            
            attribute2search4vpu= kb2kernel4vpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4vpu-using-by-create2kernel4vpu: " + str(attribute2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4vpu in keys2code4vpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu]
                    keys2line4vpu = code2examine4vpu.keys()
                    for key2line4vpu in keys2line4vpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu] [key2line4vpu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4vpu,tag2search4vpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "vpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4vpu,value2search4vpu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4vpu-skipped-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "vpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4vpu,attribute2search4vpu)             # ....function = "vpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4vpu-warning-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4vpu-accepted-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "vpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4vpu = line2examine4vpu[index2function:index2usage-2]
                                    
                                    task4kernel2vpu ['FUNCTION'] ['.py'] [key2pythonfunction4vpu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4vpu-used-by-create2kernel4vpu: " + str(key2pythonfunction4vpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # vpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2vpu-failed-by-create2kernel4vpu: " + str(task4kernel2vpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2vpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4vpu-set-by-create2kernel4vpu to: " + str(task4kernel2vpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4vpu      = kb2kernel4vpu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4vpu-using-by-create2kernel4vpu: " + str(tag2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4vpu= kb2kernel4vpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4vpu-using-by-create2kernel4vpu: " + str(attribute2search4vpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4vpu in keys2code4vpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4vpu-using-by-create2kernel4vpu: " + str(key2code4vpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # vpu2dummy4xi5test.cpp
                       
                    keys2line4vpu = code2examine4vpu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4vpu-using-by-create2kernel4vpu: " + str(keys2line4vpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4vpu in keys2line4vpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4vpu = task4kernel2vpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4vpu] [key2line4vpu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4vpu,tag2search4vpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4vpu-examining-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4vpu-using-by-create2kernel4vpu: " + str(attribute2search4vpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4vpu,attribute2search4vpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4vpu-skipped-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4vpu-accepted-by-create2kernel4vpu: " + str(line2examine4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4vpu = line2examine4vpu[27:index2usage-2]  
                                task4kernel2vpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4vpu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4vpu-used-by-create2kernel4vpu: " + str(key2kernelfunction4vpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-vpu2kernel4xi-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4vpu: " + str(task4kernel2vpu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'vpu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            vpu2kernel4xi['FUNCTION']  = task4kernel2vpu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4vpu: " + str(vpu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'vpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4vpu = vpu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4vpu-returning-by-create2kernel4vpu: " + str(keys2kernel4vpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4vpu = vpu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4vpu-returning-by-create2kernel4vpu: " + str(keys2programkernel4vpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # vpu2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4vpu-returning-by-create2kernel4vpu: " + str(vpu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'vpu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return vpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4vpu" usage = "
#     
#   print('(Step 3A2/700) OF VPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'vpu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'vpu2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4vpu + 'vpu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'vpu2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4vpu(task4add2kernel)
#       print('(Step 3A3/700) OF VPU2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF VPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4vpu(task4kernel2vpu):

    '''
    adds to kernel for VPU
    '''
    global vpu2kernel4xi                                                                                            # Kernel of VPU    
    global folder2lib4vpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4vpu" 
    method2print = "add2kernel4vpu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4vpu-started: " + str(add2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2vpu-to-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2vpu ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4vpu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  vpu2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4vpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4vpu = create2kernelsinkernel4vpu()
            keys2createwb4vpu = response2createwb4vpu.keys()
            for key2createwb4vpu in keys2createwb4vpu:
                if key2createwb4vpu == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4vpu-created-by-add2kernel4vpu: " + str(key2createwb4vpu) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  vpu2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4vpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; vpu2kernel4xi-failed-by-add2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4vpu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4vpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4vpu +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        vpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2vpu ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2vpu-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4vpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4vpu +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2vpu-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4vpu to: " + str(vpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2vpu-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        vpu2kernel4xi ['COUNT4KERNEL'] = vpu2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4vpu to: " + str(vpu2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2vpu-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        vpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2vpu['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4vpu to: " + str(vpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2vpu-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2vpu-failed-by-add2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4vpu: " + str(vpu2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = vpu2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4vpu: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4vpu +  


    keys2kernel4vpu = vpu2kernel4xi.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4vpu-returning-by-add2kernel4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return vpu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4vpu" usage = "
#     
#   print('(Step 2A2/700) OF VPU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4vpu()
#   except:
#       print('(Step 2Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4vpu(task4program2vpu=None):

    '''
    executes native kernel of VPU
    '''
    global vpu2kernel4xi                                                                                            # Kernel of VPU    
    global import2use4vpu                                                                                           # Imports of VPU
    global target2function4vpu                                                                                      # Target function of Process4Xi
    global folder2lib4vpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4vpu" 
    method2print = "execute2nativekernel4vpu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4vpu-started: " + str(execute2nativekernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2vpu-to-execute2nativekernel4vpu: " + str(task4program2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4vpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4vpu-initialized-by-execute2nativekernel4vpu to: " + str(kernel2program4vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2vpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2vpu-yielded-by-execute2nativekernel4vpu: " + str(task4program2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR VPU ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4vpu = vpu2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4vpu-using-by-execute2nativekernel4vpu: " + str(keys2kernel4vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "vpu"
        
        for key2kernel4vpu in keys2kernel4vpu:
            index2search=str.find(key2kernel4vpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4vpu[index2search:]                                                          # vpu2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4vpu = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4vpu-set-by-execute2nativekernel4vpu to: " + str(target2execute4vpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4vpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4VPU 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4vpu.get(target2execute4vpu, handle2error4vpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4vpu-imported-by-execute2nativekernel4vpu: " + str(target2execute4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4vpu-failed-by-execute2nativekernel4vpu: " + str(import2use4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4vpu-used-by-execute2nativekernel4vpu: " + str(target2execute4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4VPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2vpu = Process4Xi(target=target2function4vpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2vpu-created-by-execute2nativekernel4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2vpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2vpu-started-by-execute2nativekernel4vpu: " + str(p2vpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4vpu = p2vpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4vpu: " + str(status2process4vpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2vpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2vpu-run-by-execute2nativekernel4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4vpu-failed-by-execute2nativekernel4vpu: " + str(p2kernel4vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = vpu2kernel4xi['CODE4KERNEL'][key2kernel4vpu].keys()     
            kernel2program4vpu[key2kernel4vpu] = ""
            for key2line in keys2lines:
                code2add4vpu = vpu2kernel4xi ['CODE4KERNEL'] [key2kernel4vpu] [key2line]
                kernel2program4vpu[key2kernel4vpu] = kernel2program4vpu[key2kernel4vpu] + code2add4vpu.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4vpu-saved-by-execute2nativekernel4vpu to: " + str(len(kernel2program4vpu[key2kernel4vpu]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4vpu-set-by-execute2nativekernel4vpu to: " + str(len(kernel2program4vpu))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4vpu: " + str(vpu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4vpu = kernel2program4vpu.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4vpu-returning-by-execute2nativekernel4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4vpu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4vpu" usage = "
#     
#   print('(Step 3A3/700) OF VPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'vpu2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4vpu + 'vpu2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4vpu(task4delete2kernel) 
#       print('(Step 3A3/700) OF VPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF VPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4vpu(task4kernel2vpu):

    '''
    deletes kernel for VPU
    '''
    global vpu2kernel4xi                                                                                     
    global folder2lib4vpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4vpu" 
    method2print = "delete2kernel4vpu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4vpu-started: " + str(delete2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4vpu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2vpu-to-delete2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2vpu ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4vpu: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR VPU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4vpu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del vpu2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4vpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del vpu2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4vpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                vpu2kernel4xi ['COUNT4KERNEL'] = vpu2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4vpu: " + str(vpu2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4vpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2vpu-vpu2kernel4xi-failed-by-delete2kernel4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = vpu2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4vpu: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4vpu = vpu2kernel4xi.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4vpu-returning-by-delete2kernel4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return vpu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4vpu" usage = "
#     
#   print('(Step 3A1/700) OF VPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR VPU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4vpu()
#       print('(Step 3A2/700) OF VPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR VPU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR VPU *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4vpu(task4kernel2vpu=None):

    '''
    creates kernels in program for VPU
    '''
    global vpu2kernel4xi                                                                                            # Kernel of VPU    
    global folder2lib4vpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4vpu" 
    method2print = "create2kernelsinprogram4vpu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4vpu-started: " + str(create2kernelsinprogram4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2vpu-to-create2kernelsinprogram4vpu: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4vpu = vpu2kernel4xi.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4vpu-returning-by-create2kernelsinprogram4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return vpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4vpu" usage = "
#   fetch2kernel4vpu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4vpu(program2explore4vpu):
    global fetch2code4vpu                                                                                           # dictionary to receive files 
        
    global kb2fetch4vpu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4vpu                                                                                         # file extensions 
    
    global folder2lib4vpu  

    class2print  = "fetch2kernel4vpu"
    method2print = "fetch2kernel4vpu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4vpu-passed-to-fetch2kernel4vpu: " + str(program2explore4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4vpu + vpu2buffer4xi.py          ... vpu2sampler4xi5test.py ... vpu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\vpu2buffer4xi.cpython-33.pyc   ... vpu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\vpu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4vpu=os.path.splitext(program2explore4vpu)                                                          # vpu2sampler4xi5test + py

    key2extension4vpu = name2program4vpu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4vpu-set-by-fetch2kernel4vpu to: " + str(key2extension4vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4vpu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4vpu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4vpu-analyzing-by-fetch2kernel4vpu: " + str(program2explore4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4vpu +  vpu2buffer4xi.py ; vpu2sampler4xi5test.py ...  ... __pycache__\vpu2sampler4xi5test.cpython-33.pyc
        # vpu2dummy4xi5test.cpp
             
        path2input4vpu = program2explore4vpu
        message2print = "{(Step 1B/33) set" + "; path2input4vpu-set-by-fetch2kernel4vpu to: " + str(path2input4vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4vpu +  vpu2buffer4xi.py ; __pycache__\vpu2sampler4xi5test.cpython-33.pyc; vpu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4vpu-analyzing-by-fetch2kernel4vpu: " + str(path2input4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4vpu +  vpu2buffer4xi.py ; vpu2dummy4xi5test.cpp 
            
        keys2fetch4vpu = kb2fetch4vpu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4vpu-using-by-fetch2kernel4vpu: " + str(keys2fetch4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4vpu in keys2fetch4vpu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4vpu,kb2fetch4vpu[key2fecth4vpu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4vpu-skipped-by-fetch2kernel4vpu: " + str(path2input4vpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4vpu +  vpu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4vpu: " + str(path2input4vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4vpu +  vpu2sampler4xi5test.py; __pycache__//vpu2sampler4xi.cpython-33.pyc; 
                #               +  vpu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4vpu == '.py') or (key2extension4vpu == '.cpp') or (key2extension4vpu == '.c') or (key2extension4vpu == '.cl')):
                    file2input4vpu = open(path2input4vpu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4vpu-opened-by-fetch2kernel4vpu: " + str(file2input4vpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4vpu + 'vpu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4vpu == '.pyc') or (key2extension4vpu == '.exe')):
                    file2input4vpu = open(path2input4vpu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4vpu-opened-by-fetch2kernel4vpu: " + str(file2input4vpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//vpu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4vpu = path2input4vpu
                fetch2code4vpu[key2save4vpu] = {}                                                                   # fetch2code4vpu['vpu2sampler4xi5test.py'] = {}
                number2line4vpu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4vpu-saving-by-fetch2kernel4vpu: " + str(key2fecth4vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4vpu = file2input4vpu.readline()  
                    if not line2process4vpu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4vpu-read-by-fetch2kernel4vpu: " + str(line2process4vpu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of vpu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4vpu = number2line4vpu + 1
                            fetch2code4vpu[key2save4vpu][number2line4vpu] = line2process4vpu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4vpu-failed-by-fetch2kernel4vpu: " + str(key2fecth4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4vpu-failed-by-fetch2kernel4vpu: " + str(line2process4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4vpu-failed-by-fetch2kernel4vpu: " + str(number2line4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4vpu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4vpu-closed-by-fetch2kernel4vpu: " + str(file2input4vpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4vpu + 'vpu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4vpu + 'vpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # vpu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//vpu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # vpu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4vpu-saved-by-fetch2kernel4vpu: " + str(fetch2code4vpu[key2save4vpu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4vpu-saved-by-fetch2kernel4vpu: " + str(fetch2code4vpu[key2save4vpu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # vpu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4vpu-saved-by-fetch2kernel4vpu: " + str(fetch2code4vpu[key2save4vpu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "vpu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4vpu-saved-by-fetch2kernel4vpu: " + str(fetch2code4vpu[key2save4vpu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests vpu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4vpu-skipped-by-fetch2kernel4vpu: " + str(name2program4vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4vpu + '__pycache__//vpu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4vpu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4vpu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4vpu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4vpu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4vpu" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF VPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4vpu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4vpu(task4set2kernelws)
#       print('(Step 17G/700) OF VPU2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4vpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4vpu(task4kernelset2vpu=None):

    '''
    sets kernels for VPU
    '''
    global vpu2kernel4xi  
    global folder2lib4vpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4vpu"
    method2print = "set2kernel4vpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4vpu-started: " + str(set2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4vpu at 0x0000000003837948> 
    
    keys2task = task4kernelset2vpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4vpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if vpu2kernel4xi is None:
            vpu2kernel4xi = create2kernel4vpu()                                                                              # INITIALIZE PROGRAM FOR VPU 
            message2print = "{(Step 1C/70) set" + "; vpu2kernel4xi-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4vpu-skipped-by-set2kernel4vpu: " + str(create2kernel4vpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            vpu2kernel4xi = create2kernel4vpu()
            message2print = "{(Step 1E/70) set" + "; vpu2kernel4xi-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            vpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['DATA2CALLBACK'] = task4kernelset2vpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2vpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['PLATFORM'] = task4kernelset2vpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2vpu-try-by-set2kernel4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['CONTEXT'] = task4kernelset2vpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['DEVICE'] = task4kernelset2vpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['CODE2ERROR'] = task4kernelset2vpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['QUEUE'] = task4kernelset2vpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['PIPE'] = task4kernelset2vpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-vpu2kernel4xi-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['COMMANDQUEUE']  = task4kernelset2vpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['BUFFER']  = task4kernelset2vpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['EVENT']  = task4kernelset2vpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['COUNT4PY']  = task4kernelset2vpu['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['COUNT4PYC']  = task4kernelset2vpu['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['COUNT4C']  = task4kernelset2vpu['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['COUNT4BIN']  = task4kernelset2vpu['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4vpu: " + str(task4kernelset2vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        vpu2kernel4xi['DIRECTORY4PY']  = task4kernelset2vpu['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4vpu-set-by-set2kernelwithdirectory2py4vpu4vpu to: " + str(vpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4vpu-yielded-by-set2kernelwithdirectory2py4vpu4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        vpu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2vpu['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4vpu-set-by-set2kernelwithdirectory2pyc4vpu4vpu to: " + str(vpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4vpu-yielded-by-set2kernelwithdirectory2pyc4vpu4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        vpu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2vpu['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4vpu-set-by-set2kernelwithdirectory2c4vpu4vpu to: " + str(vpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4vpu-yielded-by-set2kernelwithdirectory2c4vpu4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        vpu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2vpu['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4vpu-set-by-set2kernelwithdirectory2bin4vpu4vpu to: " + str(vpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4vpu-yielded-by-set2kernelwithdirectory2bin4vpu4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['CODE4PY']  = task4kernelset2vpu['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4vpu + 'vpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "vpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4vpu2nack  = code2py4vpu2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['CODE4CPP']  = task4kernelset2vpu['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4vpu + 
 
        code2c4vpu2ack  = code2c4vpu2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4vpu2nack  = code2c4vpu2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['CODE4PYC']  = task4kernelset2vpu['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4vpu + 
 
        code2pyc4vpu2ack  = code2pyc4vpu2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4vpu2nack  = code2pyc4vpu2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['CODE4BIN']  = task4kernelset2vpu['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4vpu + 
 
        code2bin4vpu2ack  = code2bin4vpu2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4vpu-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4vpu2nack  = code2bin4vpu2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['SIZE4PY']  = task4kernelset2vpu['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4vpu-yielded-by-set2kernel4vpu: " + str(task4kernelset2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['SIZE4C']  = task4kernelset2vpu['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4vpu-yielded-by-set2kernel4vpu: " + str(task4kernelset2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['SIZE4PYC']  = task4kernelset2vpu['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4vpu-yielded-by-set2kernel4vpu: " + str(task4kernelset2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4vpu-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['SIZE4BIN']  = task4kernelset2vpu['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4vpu-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4vpu-yielded-by-set2kernel4vpu: " + str(task4kernelset2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['LANGUAGE']  = task4kernelset2vpu['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2vpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4vpu to: " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4vpu = vpu2kernel4xi.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4vpu-returning-by-set2kernel4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return vpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4vpu" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF VPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4vpu)   
#   # <function set2kernelarg4vpu at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4vpu(task4set2kernelargws)
#       print('(Step 17G/700) OF VPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4vpu)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4vpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4vpu(task4kernelargset2vpu=None):

    '''
    sets kernel arguments for VPU
    '''
    global vpu2kernel4xi  
    global folder2lib4vpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4vpu"
    method2print = "set2kernelarg4vpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4vpu-started: " + str(set2kernelarg4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4vpu at 0x0000000003837948> 
    
    keys2task = task4kernelargset2vpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4vpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if vpu2kernel4xi is None:
            vpu2kernel4xi = create2kernel4vpu()                                                                              # INITIALIZE PROGRAM FOR VPU 
            message2print = "{(Step 1C/70) set" + "; vpu2kernel4xi-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4vpu-skipped-by-set2kernelarg4vpu: " + str(create2kernel4vpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            vpu2kernel4xi = create2kernel4vpu()
            message2print = "{(Step 1E/70) set" + "; vpu2kernel4xi-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            vpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['DATA2CALLBACK'] = task4kernelargset2vpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2vpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['PLATFORM'] = task4kernelargset2vpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2vpu-try-by-set2kernelarg4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['CONTEXT'] = task4kernelargset2vpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['DEVICE'] = task4kernelargset2vpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['CODE2ERROR'] = task4kernelargset2vpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['QUEUE'] = task4kernelargset2vpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['PIPE'] = task4kernelargset2vpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-vpu2kernel4xi-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['COMMANDQUEUE']  = task4kernelargset2vpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['BUFFER']  = task4kernelargset2vpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4vpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['EVENT']  = task4kernelargset2vpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        vpu2kernel4xi['COUNT4SOURCE']  = task4kernelargset2vpu['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4vpu: " + str(task4kernelargset2vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        vpu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2vpu['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4vpu to: " + str(vpu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['CODE4SOURCE']  = task4kernelargset2vpu['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4vpu + 'vpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "vpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['SIZE4SOURCE']  = task4kernelargset2vpu['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4vpu: " + str(task4kernelargset2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2vpu['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4vpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        vpu2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2vpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4vpu to: " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4vpu = vpu2kernel4xi.keys()
    for key2kernelarg4vpu in keys2kernelarg4vpu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4vpu-returning-by-set2kernelarg4vpu: " + str(key2kernelarg4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return vpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4vpu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF VPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF VPU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4vpu(task4release2kernel)
#       print('(Step 18B/700) OF VPU2KERNEL4XI5TEST - RELEASED KERNEL OF VPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF VPU DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4vpu(task4release2vpu=None):

    '''
    releases kernel for VPU
    '''
    global vpu2kernel4xi  
    global folder2lib4vpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4vpu"
    method2print = "release2kernel4vpu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4vpu-started: " + str(release2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2vpu-to-release2kernel4vpu: " + str(task4release2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if vpu2kernel4xi is None:
            vpu2kernel4xi = create2kernel4vpu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            vpu2kernel4xi = create2kernel4vpu()
        except:
            vpu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; vpu2kernel4xi-yielded-by-release2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4vpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2vpu is None:
        task4release2vpu = {}
        task4release2vpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        vpu2kernel4xi['COUNT2REFERENCE'] = vpu2kernel4xi['COUNT2REFERENCE'] - task4release2vpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4vpu: " + str(vpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if vpu2kernel4xi['COUNT2REFERENCE'] < 0:
            vpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4vpu: " + " ** " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            vpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4vpu: " + " ** " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; vpu2kernel4xi-yielded-by-release2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4vpu = vpu2kernel4xi.keys()
    for key2program4vpu in keys2program4vpu:
        message2print = "{(Step 70/70) returning" + "; key2program4vpu-returning-by-release2kernel4vpu: " + str(key2program4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return vpu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4vpu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF VPU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF VPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4vpu(task4retain2kernel)
#       print('(Step 19B/700) OF VPU2KERNEL4XI5TEST - RETAINED PROGRAM OF VPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF VPU DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4vpu(task4retain2vpu=None):

    '''
    retains kernel of VPU
    '''
    global vpu2kernel4xi 
    global folder2lib4vpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4vpu"
    method2print = "retain2kernel4vpu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4vpu-started: " + str(retain2kernel4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2vpu-to-retain2kernel4vpu: " + str(task4retain2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2vpu is None:
        task4retain2vpu = {}
        task4retain2vpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2vpu-set-by-retain2kernel4vpu to: " + str(task4retain2vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2vpu.keys():
        pass
    else:
        task4retain2vpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4vpu to: " + str(task4retain2vpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2vpu['COUNT2REFERENCE'] < 1:
        task4retain2vpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4vpu to: " + str(task4retain2vpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if vpu2kernel4xi is None:
            vpu2kernel4xi = create2kernel4vpu()
            message2print = "{(Step 4A/70) created" + "; vpu2kernel4xi-created-by-retain2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            vpu2kernel4xi = create2kernel4vpu()
            message2print = "{(Step 4B/70) created" + "; vpu2kernel4xi-created-by-retain2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            vpu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; vpu2kernel4xi-yielded-by-retain2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        vpu2kernel4xi['COUNT2REFERENCE'] = vpu2kernel4xi['COUNT2REFERENCE'] + task4retain2vpu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4vpu: " + str(vpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if vpu2kernel4xi['COUNT2REFERENCE'] <= 0:
            vpu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4vpu: " + " ** " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            vpu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4vpu: " + " ** " + str(vpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; vpu2kernel4xi-yielded-by-retain2kernel4vpu: " + str(vpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4vpu = vpu2kernel4xi.keys()
    for key2program4vpu in keys2program4vpu:
        message2print = "{(Step 70/70) returning" + "; key2program4vpu-returning-by-retain2kernel4vpu: " + str(key2program4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return vpu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4vpu" usage = "
#
#   print('(Step 3B1/700) OF VPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR VPU ', time4xi())     
#   try:
#       response4kernelinfo2vpu = get2kernelinfo4vpu() 
#       print('(Step 3B2/700) OF VPU2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR VPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF VPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR VPU', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4vpu(task4getinfo2kernel=None):

    '''
    gets kernel information of VPU
    '''
    
    global vpu2kernel4xi
    global folder2lib4vpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4vpu"
    method2print = "get2kernelinfo4vpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4vpu-started: " + str(get2kernelinfo4vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4vpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    vpu2kernel = {}
    try: 
        if vpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR VPU           
            # -------------------------------------------------------------------------------------           
            vpu2kernel = create2kernel4vpu()
            message2print = "{(Step 1B2/33) initialized" + "; vpu2kernel-initialized-by-get2kernelinfo4vpu to: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; vpu2kernel4xi-using-by-get2kernelinfo4vpu: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF VPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            vpu2kernel = vpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; vpu2kernel-got-by-get2kernelinfo4vpu: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF VPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4vpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                vpu2kernel [key2task] = vpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-vpu2kernel-set-by-get2kernelinfo4vpu to: " + str(vpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4vpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4vpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; vpu2kernel4xi-using-by-get2kernel4vpu: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            vpu2kernel = create2kernel4vpu()
            
            message2print = "{(Step 1F/33) initialized" + "; vpu2kernel-initialized-by-get2kernelinfo4vpu to: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                vpu2kernel = vpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; vpu2kernel-set-by-get2kernelinfo4vpu to: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4vpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        vpu2kernel [key2task] = vpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-vpu2kernel -set-by-get2kernelinfo4vpu to: " + str(vpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4vpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            vpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; vpu2kernel-yielded-by-get2kernel4vpu: " + str(vpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4vpu = vpu2kernel4xi.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4vpu-returning-by-get2kernelinfo4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return vpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4vpu" usage = "
#
#   print('(Step 3B1/700) OF VPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR VPU ', time4xi())     
#   try:
#       response4kernelinfo2vpu = get2kernelarginfo4vpu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF VPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR VPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF VPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR VPU ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4vpu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of VPU
    '''
    
    global vpu2kernel4xi
    global folder2lib4vpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4vpu"
    method2print = "get2kernelarginfo4vpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4vpu-started: " + str(get2kernelarginfo4vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4vpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    vpu2kernel = {}
    try: 
        if vpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR VPU           
            # -------------------------------------------------------------------------------------           
            vpu2kernel = create2kernel4vpu()
            message2print = "{(Step 1B2/33) initialized" + "; vpu2kernel-initialized-by-get2kernelarginfo4vpu to: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; vpu2kernel4xi-using-by-get2kernelarginfo4vpu: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF VPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            vpu2kernel = vpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; vpu2kernel-got-by-get2kernelarginfo4vpu: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF VPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4vpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                vpu2kernel [key2task] = vpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-vpu2kernel-set-by-get2kernelarginfo4vpu to: " + str(vpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4vpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4vpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; vpu2kernel4xi-using-by-get2kernel4vpu: " + str(vpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            vpu2kernel = create2kernel4vpu()
            
            message2print = "{(Step 1F/33) initialized" + "; vpu2kernel-initialized-by-get2kernelarginfo4vpu to: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                vpu2kernel = vpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; vpu2kernel-set-by-get2kernelarginfo4vpu to: " + str(vpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4vpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        vpu2kernel [key2task] = vpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-vpu2kernel -set-by-get2kernelarginfo4vpu to: " + str(vpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4vpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            vpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; vpu2kernel-yielded-by-get2kernel4vpu: " + str(vpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4vpu = vpu2kernel4xi.keys()
    for key2kernel4vpu in keys2kernel4vpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4vpu-returning-by-get2kernelarginfo4vpu: " + str(key2kernel4vpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return vpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4vpu" usage = "
#
#   response4get2buildinfo = get2buildinfo4vpu()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4vpu(task4getinfo2build=None):

    '''
    gets vpu2build4xi and vpu2build4xi
    '''
    
    global vpu2build4xi
    global folder2lib4vpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4vpu"
    method2print = "get2buildinfo4vpu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4vpu-started: " + str(get2buildinfo4vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4vpu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    vpu2build = {}
    try: 
        if vpu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR VPU           
            # -------------------------------------------------------------------------------------           
            vpu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; vpu2build-initialized-by-get2buildinfo4vpu to: " + str(vpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; vpu2build4xi-using-by-get2buildinfo4vpu: " + str(vpu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF VPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            vpu2build = vpu2build4xi
            message2print = "{(Step 1C/33) using" + "; vpu2build-got-by-get2buildinfo4vpu: " + str(vpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF VPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4vpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                vpu2build [key2task] = vpu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-vpu2build-set-by-get2buildinfo4vpu to: " + str(vpu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4vpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4vpu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; vpu2build4xi-using-by-get2build4vpu: " + str(vpu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            vpu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; vpu2build-initialized-by-get2buildinfo4vpu to: " + str(vpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                vpu2build = vpu2build4xi
                message2print = "{(Step 1G/33) set" + "; vpu2build-set-by-get2buildinfo4vpu to: " + str(vpu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4vpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        vpu2build [key2task] = vpu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-vpu2build -set-by-get2buildinfo4vpu to: " + str(vpu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4vpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            vpu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; vpu2build-yielded-by-get2build4vpu: " + str(vpu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; vpu2build-returning-by-get2buildinfo4vpu: " + str(vpu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return vpu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4vpu" usage = "
#     
#   print('(Step 2AB2/700) OF VPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4vpu()
#       print('(Step 2BB2/700) OF VPU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF VPU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4vpu(task4kernelworkgroupinfo2vpu=None):

    '''
    gets kernel workgroup info of VPU
    '''
    global vpu2kernel4xi                                                                                            # Kernel of VPU    
    global import2use4vpu                                                                                           # Imports of VPU
    global target2function4vpu                                                                                      # Target function of Process4Xi
    global folder2lib4vpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4vpu" 
    method2print = "get2kernelworkgroupinfo4vpu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4vpu-started: " + str(get2kernelworkgroupinfo4vpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2vpu-to-get2kernelworkgroupinfo4vpu: " + str(task4kernelworkgroupinfo2vpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4vpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2vpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2vpu-yielded-by-get2kernelworkgroupinfo4vpu: " + str(task4kernelworkgroupinfo2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR VPU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4vpu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4vpu-initialized-by-get2kernelworkgroupinfo4vpu to: " + str(process2kernelworkgroupinfo4vpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4vpu = vpu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4vpu-using-by-get2kernelworkgroupinfo4vpu: " + str(keys2code4vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4vpu + 'vpu2sampler4xi5test.py'])
        
        unit4processing = "vpu"
        
        for key2code4vpu in keys2code4vpu:
            index2search=str.find(key2code4vpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4vpu[index2search:]                                                          # vpu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4vpu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4vpu-set-by-get2kernelworkgroupinfo4vpu to: " + str(target2link4vpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # vpu2sampler4xi5test

                    p2code4vpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4VPU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4vpu.get(target2link4vpu, handle2error4vpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4vpu-imported-by-get2kernelworkgroupinfo4vpu: " + str(target2link4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # vpu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4vpu-failed-by-get2kernelworkgroupinfo4vpu: " + str(import2use4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4vpu-used-by-get2kernelworkgroupinfo4vpu: " + str(target2link4vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4VPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2vpu = Process4Xi(target=target2function4vpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2vpu-created-by-get2kernelworkgroupinfo4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4vpu[key2code4vpu] = p2vpu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2vpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2vpu-started-by-get2kernelworkgroupinfo4vpu: " + str(p2vpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4vpu = p2vpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4vpu: " + str(status2process4vpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2vpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2vpu-run-by-get2kernelworkgroupinfo4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4vpu: " + str(p2vpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4vpu-failed-by-get2kernelworkgroupinfo4vpu: " + str(p2code4vpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4vpu-set-by-get2kernelworkgroupinfo4vpu to: " + str(process2kernelworkgroupinfo4vpu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4vpu: " + str(vpu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    vpu2kernel4xi ['ACK2RETURN']  = code2ack
    vpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4vpu-returning-by-get2kernelworkgroupinfo4vpu: " + str(process2kernelworkgroupinfo4vpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4vpu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "VPU2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for VPU kernels" usage = "Kernel4Xi of VPU"
#>

# =================================================================================================
class VPU2Kernel4Xi(object): 
    ''' 
    VPU2Kernel4Xi offers  methods for VPU kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2vpu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF VPU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF VPU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2vpu = VPU2Kernel4Xi()
    #       print('(Step 110B/700) OF VPU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF VPU: ', kernelobject2vpu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF VPU') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2vpu = None):
        '''
        _init__ method initializes VPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "VPU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-VPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; vpu2kernel2xi-of-VPU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-vpu2kernel2xi-of-VPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2vpu-sharing-by-vpu2kernel2xi-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi.classvariable2vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2vpu-passed-to-init-of-VPU2Kernel4Xi: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2vpu-passing-to-create2kernel4vpu-by-init-of-VPU2Kernel4Xi: " + str(task4kernel2vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        vpu2kernel2xi = create2kernel4vpu(task4kernel2vpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4vpu-performed-by-init-of-VPU2Kernel4Xi: " + str(create2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4vpu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; vpu2kernel2xi-of-VPU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-vpu2kernel2xi-of-VPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2vpu-shared-by-vpu2kernel2xi-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi.classvariable2vpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-VPU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-VPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF VPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO VPU  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'vpu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'vpu2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2vpu.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF VPU2KERNEL4XI5TEST - ADDED KERNEL TO VPU  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO VPU WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-VPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4vpu-by-add2kernel-of-VPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4vpu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4vpu-performed-by-add2kernel-of-VPU2Kernel4Xi: " + str(add2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-VPU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF VPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF VPU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2vpu.execute2task() 
    #       print('(Step 240B/700) OF VPU2KERNEL4XI5TEST - EXECUTED TASK OF VPU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF VPU WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-VPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4vpu-by-execute2task-of-VPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        vpu2program2xi = execute2task4vpu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4vpu-performed-by-execute2task-of-VPU2Kernel4Xi: " + str(execute2task4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; vpu2program2xi-returning-by-execute2task-of-VPU2Kernel4Xi: " + str(vpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return vpu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF VPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF VPU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2vpu.execute2nativekernel()
    #       print('(Step 121A2/700) OF VPU2KERNEL4XI5TEST - EXECUTED KERNEL OF VPU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF VPU', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-VPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4vpu-by-execute2nativekernel-of-VPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        vpu2execute2xi = execute2nativekernel4vpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4vpu-performed-by-execute2nativekernel-of-VPU2Kernel4Xi: " + str(execute2nativekernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; vpu2execute2xi-returning-by-execute2nativekernel-of-VPU2Kernel4Xi: " + str(vpu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return vpu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF VPU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF VPU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2vpu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF VPU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF VPU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF VPU WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-VPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-VPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4vpu-by-get2kernelworkgroupinfo-of-VPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        vpu2program2xi = get2kernelworkgroupinfo4vpu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4vpu-performed-by-get2kernelworkgroupinfo-of-VPU2Kernel4Xi: " + str(get2kernelworkgroupinfo4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; vpu2program2xi-returning-by-get2kernelworkgroupinfo-of-VPU2Kernel4Xi: " + str(vpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return vpu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF VPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR VPU ', time4xi()) 
    #   try:
    #       kernelobject2vpu = VPU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2vpu.create2kernel()
    #       print('(Step 190B/700) OF VPU2KERNEL4XI5TEST - CREATED KERNEL FOR VPU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR VPU ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of VPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-VPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4vpu-by-create2kernel-of-VPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        vpu2kernel2xi = create2kernel4vpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4vpu-performed-by-create2kernel-of-VPU2Kernel4Xi: " + str(create2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4vpu at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = vpu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-VPU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # vpu2sampler4xi5test 
        
        return vpu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF VPU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR VPU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2vpu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF VPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR VPU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR VPU', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-VPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4vpu-by-create2kernelsinprogram-of-VPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        vpu2kernel2xi = create2kernelsinprogram4vpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4vpu-performed-by-create2kernelsinprogram-of-VPU2Kernel4Xi: " + str(create2kernelsinprogram4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4vpu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; vpu2kernel2xi-returning-by-create2kernelsinprogram-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return vpu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-VPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF VPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF VPU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4vpu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4vpu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2vpu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF VPU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of VPUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF VPU WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-VPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4vpu-by-delete2kernel-of-VPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4vpu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4vpu-performed-by-delete2kernel-of-VPU2Kernel4Xi: " + str(delete2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-VPU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-VPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF VPU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF VPU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2vpu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF VPU2KERNEL4XI5TEST - SET KERNEL OF VPU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF VPU: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel VPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-VPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4vpu-by-set2kernel-of-VPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        vpu2kernel2xi = set2kernel4vpu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4vpu-performed-by-set2kernel-of-VPU2Kernel4Xi: " + str(set2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; vpu2kernel2xi-returning-by-set2kernel-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return vpu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-VPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF VPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR VPU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2vpu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF VPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR VPU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR VPU ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-VPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4vpu-by-set2kernelarg-of-VPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        vpu2program2xi = set2kernelarg4vpu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4vpu-performed-by-set2kernelarg-of-VPU2Kernel4Xi: " + str(set2kernelarg4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; vpu2program2xi-returning-by-set2kernelarg-of-VPU2Kernel4Xi: " + str(vpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return vpu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF VPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2vpu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF VPU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of VPU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        vpu2kernel2xi = get2kernelinfo4vpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; vpu2kernel2xi-returning-by-get2kernelinfo-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return vpu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF VPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF VPU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2vpu.get2kernelarginfo()
    #       print('(Step 106B/700) OF VPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF VPU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF VPU ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of VPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        vpu2kernel2xi = get2kernelarginfo4vpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; vpu2kernel2xi-returning-by-get2kernelarginfo-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return vpu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF VPU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2vpu.get2buildinfo()
    #       print('(Step 106A2/700) OF VPU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF VPU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of VPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        vpu2build2xi = get2buildinfo4vpu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; vpu2build2xi-returning-by-get2buildinfo-of-VPU2Kernel4Xi: " + str(vpu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return vpu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF VPU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2vpu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF VPU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases VPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-VPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4vpu-by-release2kernel-of-VPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        vpu2kernel2xi = release2kernel4vpu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4vpu-performed-by-release2kernel-of-VPU2Kernel4Xi: " + str(release2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; vpu2kernel2xi-returning-by-release2kernel-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return vpu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF VPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2vpu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF VPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF VPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains VPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-VPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4vpu-by-retain-of-VPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        vpu2kernel2xi = retain2kernel4vpu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4vpu-performed-by-retain2kernel-of-VPU2Kernel4Xi: " + str(retain2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; vpu2kernel2xi-returning-by-retain2kernel-of-VPU2Kernel4Xi: " + str(vpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return vpu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-VPU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF VPU2KERNEL4XI5TEST - TRYING TO TRACE VPU: ', time4xi())      
    #   trace2vpu = None
    #   try:
    #       trace2vpu = programobject2vpu.trace2kernel() 
    #               print('(Step 210B/25) OF VPU2KERNEL4XI5TEST - TRACE2VPU: ', trace2vpu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4vpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4vpu', 'METHOD': 'trace2kernel4vpu'}
    #        except:
    #           print('(Step 210Z1/25) OF VPU2KERNEL4XI5TEST *** FAILED TO TRACE VPU: ', trace2vpu) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces VPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-VPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4vpu-by-trace2kernel-of-VPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4vpu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4vpu-performed-by-trace2kernel-of-VPU2Kernel4Xi: " + str(trace2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-VPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-VPU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF VPU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF VPU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2vpu.execute2kernel() 
    #       print('(Step 220B/25) OF VPU2KERNEL4XI5TEST - UNLOADED COMPILER OF VPU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF VPU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF VPU: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-VPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4vpu-by-execute2kernel-of-VPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4vpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4vpu-performed-by-execute2kernel-of-VPU2Kernel4Xi: " + str(execute2kernel4vpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-VPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF VPU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2VPU: ', programobject2vpu) 
    #   try:
    #       callback2vpu = programobject2vpu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF VPU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2vpu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of VPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "VPU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-VPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-VPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2vpu4program = {} 
        try:
            callback2vpu4program = set2kernelcallback4vpu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2vpu4program-failed-by-set2kernelcallback-of-VPU2Kernel4Xi: " + str(callback2vpu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2vpu4program-returning-by-set2kernelcallback-of-VPU2Kernel4Xi: " + str(callback2vpu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4vpu at 0x00000000038CF5C8> 
        
                                             
        return callback2vpu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF VPU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2vpu.sense())
    #       print('(Step 310B/700) OF VPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses VPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'VPU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; VPU2Kernel4Xi-sensing-by-sense-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-VPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2vpu-of-VPU2Kernel4Xi'] = VPU2Kernel4Xi.classvariable2vpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-VPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; VPU2Kernel4Xi-sensed-by-sense-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-VPU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-VPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF VPU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2vpu.reason())
    #       print('(Step 320B/700) OF VPU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons VPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'VPU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; VPU2Kernel4Xi-reasoning-by-reason-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-VPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-VPU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-VPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; VPU2Kernel4Xi-reasoned-by-reason-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-VPU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-VPU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF VPU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2vpu.ace())
    #       print('(Step 330B/700) OF VPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF VPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces VPU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'VPU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-VPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; VPU2Kernel4Xi-acing-by-ace-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-VPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-VPU2Kernel4Xi'] = VPU2Kernel4Xi.classvariable2vpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-VPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; VPU2Kernel4Xi-aced-by-ace-of-VPU2Kernel4Xi: " + str(VPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'vpu2codeprogram4xi.VPU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-VPU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   vpu2codeprogram4xi5test.txt
#   sense-vpu2codeprogram4xi5test.xml
#   reason-vpu2codeprogram4xi5test.xml
#   ace-vpu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of vpu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
